"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  getBabelConfig: true
};
exports.default = _default;
exports.getBabelConfig = void 0;

var _babelPresetBase = require("@modern-js/babel-preset-base");

Object.keys(_babelPresetBase).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _babelPresetBase[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _babelPresetBase[key];
    }
  });
});

var _generate = require("./generate");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const defaultOptions = {
  appDirectory: process.cwd(),
  metaName: 'modern-js',
  target: 'client',
  modules: false,
  useBuiltIns: 'entry',
  useModern: false,
  useLegacyDecorators: true,
  useTsLoader: false,
  lodash: {},
  styledComponents: {}
};

const getBabelConfig = options => {
  const mergedOptions = _objectSpread(_objectSpread({}, defaultOptions), options);

  const babelChain = (0, _generate.generate)(mergedOptions, mergedOptions.chain || (0, _babelPresetBase.createBabelChain)());
  return (0, _babelPresetBase.applyUserBabelConfig)(babelChain.toJSON(), mergedOptions.userBabelConfig, mergedOptions.userBabelConfigUtils);
};

exports.getBabelConfig = getBabelConfig;

function _default(api, options) {
  api.cache(true);
  return getBabelConfig(options);
}