"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isBeyondReact17 = exports.getCoreJsVersion = void 0;

var _path = _interopRequireDefault(require("path"));

var _utils = require("@modern-js/utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const isBeyondReact17 = cwd => {
  const pkgPath = _path.default.join(cwd, 'package.json');

  if (!_utils.fs.existsSync(pkgPath)) {
    return false;
  }

  const pkgInfo = JSON.parse(_utils.fs.readFileSync(pkgPath, 'utf8'));

  const deps = _objectSpread(_objectSpread({}, pkgInfo.devDependencies), pkgInfo.dependencies);

  if (typeof deps.react !== 'string') {
    return false;
  }

  return _utils.semver.satisfies(_utils.semver.minVersion(deps.react), '>=17.0.0');
};

exports.isBeyondReact17 = isBeyondReact17;

const getCoreJsVersion = () => {
  try {
    const {
      version
    } = _utils.fs.readJSONSync(require.resolve('core-js/package.json'));

    const [major, minor] = version.split('.');
    return `${major}.${minor}`;
  } catch (err) {
    return '3';
  }
};

exports.getCoreJsVersion = getCoreJsVersion;